# =====================================================
# @(#) INFO.py                       7.2.01  1999-10-06
# =====================================================
#
#
#
#    ========== licence begin  GPL
#    Copyright (c) 2000-2004 SAP AG
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#    ========== licence end
#

#

from installib import *

def install (session,options):
    """Installing messages and help
    """

    loaderCmd (session, 'INSTALLATION ON')

    loaderCmd (session, 'AUTOCOMMIT OFF')

#   may be it exists, but is the new view, which has to remain

    if existsTable (session, "MESSAGES"):
        stopIfSqlNotErr (session, -8015, 'DROP TABLE MESSAGES')

    stopIfSqlNotErr (session, -6000,
                """CREATE VIEW MESSAGES AS
                SELECT ERRORCODE MSGNO,'ENG' LANGUAGE, ERRORTEXT MSGTEXT FROM SYSDD.KERNELMESSAGES
                INTERNAL""")

    stopIfSqlNotOK (session, 'GRANT SELECT ON MESSAGES TO PUBLIC')

    loaderCmd (session, 'COMMIT')

    loaderCmd (session, 'INSTALLATION OFF')

if __name__ == '__main__':
    connectAndInstall (install, install.__doc__)

